package models

import "rdluck_tools/orm"

type ReportMapping struct {
	CategoryId   int       `description:"分类ID"`
	SubCategoryName      string    `description:"权限名称"`
	IsRead bool  `description:"是否标红"`
}

type ReportMappingResp struct {
	List []*ReportMapping
}

//获取策略下面的所有分类
func GetReportMappingStrategyAll() (items []*ReportMapping, err error) {
	o:=orm.NewOrm()
	sql:=`SELECT * FROM cygx_report_mapping WHERE report_type=1 AND chart_permission_id=23 ORDER BY sort ASC `
	_,err=o.Raw(sql).QueryRows(&items)
	return
}

